--Global Variables
local TotalRaidMembers = GetNumGroupMembers()
local NameOfDebuff = "Runic Affinity"
local NumberOfDebuffsFound = 0
local RaidMembers = {}
local DebuffPlayers = {}
local DebuffPlayerIndex = 1
local MaxDebuffs = 6
local RaidWarningMessage = ""
local EventFrame1 = CreateFrame("Frame")

EventFrame1:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
EventFrame1:SetScript("OnEvent", function(self, event, ...)
	self:COMBAT_LOG_EVENT_UNFILTERED(CombatLogGetCurrentEventInfo())
end)

--Assign marker to debuffed players
function AssignDebuffMarker(Target, IconNumber)
	SetRaidTarget(Target,IconNumber)
	RaidWarningMessage = RaidWarningMessage .. Target .. " = {rt" .. IconNumber .. "}    "
end

--Clear marker from debuffed players
function RemoveDebuffMarker(Target)
	SetRaidTarget(Target,0)
end

--Get all buffs on a player, return debuffed players
function GetAllPlayerDebuffs(PlayerName)
	local i = 1
	local debuff = UnitDebuff(PlayerName, i)
	local PlayerRole = UnitGroupRolesAssigned(PlayerName)
	--Exclude tanks
	if PlayerRole ~= "TANK" then
		while debuff do
			if debuff == NameOfDebuff then
				debuff = nil
				DebuffPlayers[DebuffPlayerIndex] = PlayerName
				DebuffPlayerIndex = DebuffPlayerIndex + 1
			else
				i = i + 1
				debuff = UnitDebuff(PlayerName, i)
			end
		end
	end
end

--Add all raid members to an array
function ListRaidMembers(RaidSize)
		for i=1, RaidSize do
			RaidMembers[i] = GetRaidRosterInfo(i)
		end
end

--Start looking for debuffs and assign markers
function RunAssignmentProcess()
	--Update RaidMembers with all current raid members
	TotalRaidMembers = GetNumGroupMembers()
	ListRaidMembers(TotalRaidMembers)
	--Check all raid members for debuff
	for i=1, TotalRaidMembers do
		GetAllPlayerDebuffs(RaidMembers[i])
	end
	--Mark and remember list of debuffed players
	if DebuffPlayerIndex - 1 > MaxDebuffs then
		for j=1, MaxDebuffs do
			AssignDebuffMarker(DebuffPlayers[j], j)
			j = j + 1
		end				
	else			
		for j=1, DebuffPlayerIndex - 1 do
			AssignDebuffMarker(DebuffPlayers[j], j)
			j = j + 1
		end	
	end	
	--Send Raid Warning of all marked players
	SendChatMessage(RaidWarningMessage, "RAID_WARNING")
end

--Slash commands
local function SlashCommand(msg)
		if msg == 'count' then
			TotalRaidMembers = GetNumGroupMembers()
			ListRaidMembers(TotalRaidMembers)
			print("Raid size = " .. TotalRaidMembers)
		elseif msg == 'force' then
			print("Marking Triggered Manually")
			--Update RaidMembers with all current raid members
			TotalRaidMembers = GetNumGroupMembers()
			ListRaidMembers(TotalRaidMembers)
			--Check all raid members for debuff
			for i=1, TotalRaidMembers do
				GetAllPlayerDebuffs(RaidMembers[i])
			end
			--Mark and remember list of debuffed players
			if DebuffPlayerIndex - 1 > MaxDebuffs then
				for j=1, MaxDebuffs do
					AssignDebuffMarker(DebuffPlayers[j], j)
					j = j + 1
				end				
			else			
				for j=1, DebuffPlayerIndex - 1 do
					AssignDebuffMarker(DebuffPlayers[j], j)
					j = j + 1
				end	
			end
		--Send Raid Warning of all marked players
		SendChatMessage(RaidWarningMessage, "RAID_WARNING")
		else
			print("Please type '|c00FFFF00/Runic count|c00ffffff' for raid group size, or '|c00FFFF00/Runic force|c00ffffff' to run marker assignment")
		end
		
		
--Reset variables
	for i=1, DebuffPlayerIndex - 1 do
		DebuffPlayers[i] = nil
	end
	DebuffPlayerIndex = 1
	RaidWarningMessage = ""
end

--Watch event logs for debuff
function EventFrame1:COMBAT_LOG_EVENT_UNFILTERED(...)
	local timestamp, type, hideCaster, sourceGUID, sourceName, sourceFlags, sourceFlags2, destGUID, destName, destFlags, destFlags2 = ...
	if (UnitIsGroupLeader("player")) then
		local PlayerRole = UnitGroupRolesAssigned(destName)
		if PlayerRole ~= "TANK" then
			if (type=="SPELL_AURA_APPLIED") then	
				local spellId, spellName, spellSchool, auraType = select(12, ...)
					if (spellName == NameOfDebuff) then
						NumberOfDebuffsFound = NumberOfDebuffsFound + 1
						if NumberOfDebuffsFound == MaxDebuffs then
							RunAssignmentProcess()
						end
					end
			elseif (type=="SPELL_AURA_REMOVED") then
				local spellId, spellName, spellSchool, auraType = select(12, ...)
				if (spellName == NameOfDebuff) then
						NumberOfDebuffsFound = NumberOfDebuffsFound - 1
						if NumberOfDebuffsFound == 0 then
						--Reset variables and remove marks
							for i=1, DebuffPlayerIndex - 1 do
							RemoveDebuffMarker(DebuffPlayers[i])
							DebuffPlayers[i] = nil
							end
							DebuffPlayerIndex = 1
							RaidWarningMessage = ""
						end
				end		
			end
		end
	end
end

--Slash Command
SLASH_FSTest1= '/ra'
SLASH_FSTest2= '/runic'
SLASH_FSTest3= '/runicassigner'
SLASH_FSTest4= '/RA'
SLASH_FSTest5= '/Runic'
SLASH_FSTest6= '/RunicAssigner'
SlashCmdList["FSTest"] = SlashCommand
